/*
 *	main.c
 *
 *	Sl
 *
 *	* Fri Mar 21 01::00 JST 2003 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

//#define USE_MUSIC /* yCugꍇ́ÃV{`Ă */
#ifdef USE_MUSIC
#include "instdef.c"
#define music_play(data) do { music_stop(); PlayMusic((unsigned char*)(data)); } while(0)
#define music_stop() do { StopMusic(); sound_stop(music_wch); } while(0)
#else /*USE_MUSIC*/
#define music_play(data) ((void)0)
#define music_stop() ((void)0)
#endif /*USE_MUSIC*/

//#define V_SCREEN /* cʃ[hgꍇ́ÃV{`Ă */
#ifdef V_SCREEN
#undef DISP_X
#undef DISP_Y
#define DISP_X	 88
#define DISP_Y	128
#endif /*V_SCREEN*/

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
#define QUICK_REPEAT
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
#define QUICK_REPEAT_DELAY	SEC(0.25)

/* 얂~ĵĂ */
static const unsigned char SND1[] =
#include "snd/snd1.c"
static const unsigned char SND2[] =
#include "snd/snd2.c"
static const unsigned char SND3[] =
#include "snd/snd3.c"
//static const unsigned char SND4[] =
//#include "snd/snd4.c"
static const unsigned char SND5[] =
#include "snd/snd5.c"

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

#define PAT_TITLE_SX	  0	/* uSlv */
#define PAT_TITLE_SY	  0
#define PAT_TITLE_W	122
#define PAT_TITLE_H	 30
#define PAT_CORRECT_SX	 41
#define PAT_CORRECT_SY	 32
#define PAT_CORRECT_W	 80
#define PAT_CORRECT_H	 39
#define PAT_ERROR_SX	  0
#define PAT_ERROR_SY	 32
#define PAT_ERROR_W	121
#define PAT_ERROR_H	 39

/* wꂪSl񂾁Ixihttp://aririn7.cool.ne.jp/uta/utada.htmlj */
#define N_CARD	100
typedef struct _CARD {
	const char* name;	/* rݐl */
	const char* kami;	/* ̋ */
	const char* simo;	/* ̋ */
} CARD;
const CARD card_list[N_CARD] = {
	{"VqVc",
	 "H̓ĉق̈̂Ƃ܂",
	 "䂪͘Iɂʂ"},
	{"Vc",
	 "t߂ĉėɂ炵",
	 "߂قĂӓV̍R"},
	{"`{lC",
	 "Ђ̎Rǂ̔̂",
	 "ȂȂЂƂ肩˂"},
	{"RԐl",
	 "cq̉YɂłČΔ",
	 "xm̍ɐ͂ӂ"},
	{"ۑv",
	 "Rɍgtӂ݂킯Ȃ",
	 "H͂Ȃ"},
	{"[Ǝ",
	 "̂킽鋴ɂ",
	 "Ζ邼ӂɂ"},
	{"{",
	 "V̌ӂ肳ΏtȂ",
	 "O}̎Rɏoł"},
	{"@t",
	 "䂪͓ŝ݂",
	 "FRƐl͂ӂȂ"},
	{"쏬",
	 "Ԃ̐F͂ɂȂÂ",
	 "킪gɂӂȂ߂܂"},
	{"@",
	 "₱̉ւʂĂ",
	 "mmʂ̊"},
	{"Qc@",
	 "킽̌\đołʂ",
	 "lɂ͂悠܂̂M"},
	{"mՏ",
	 "VÕ_̒ʂИHƂ",
	 "Ƃ߂̎p΂Ƃǂ߂"},
	{"z@",
	 "΂˂̕肨݂Ȃ̐",
	 "ĕƂȂʂ"},
	{"͌b",
	 "̂̂ԂN",
	 "ꂻ߂ɂȂȂ"},
	{"FVc",
	 "Nߏt̖ɏołĎ؂",
	 "䂪ߎɐ͂ӂ"},
	{"[s",
	 "ʂꂢȂ΂̎R̕ɐӂ",
	 "܂Ƃ΍ւ藈"},
	{"݌ƕb",
	 "瑁Ԃ_c",
	 "炭ȂɐƂ"},
	{"qsb",
	 "Z̍]݂̊ɂg邳ւ",
	 "̒ʂИHlڂ悭"},
	{"Ɂ@",
	 "ĝ݂ӂ̊Ԃ",
	 "͂ł̐߂ĂƂ"},
	{"ǐe",
	 "тʂ΍͂gȂ",
	 "gĂ͂ނƂv"},
	{"f@t",
	 "ނƂЂ΂ɒ",
	 "Ľ҂oł邩"},
	{"NG",
	 "ɏH̑؂̂",
	 "ނ׎R炵Ƃӂ"},
	{"]痢",
	 "΂ɂ̂߂",
	 "킪gЂƂ̏Hɂ͂˂"},
	{"@",
	 "̂т͕肠ւR",
	 "gt̂ɂ_̂܂ɂ܂"},
	{"OEb",
	 "ɂ͂ΈR̂˂Â",
	 "lɒmł悵"},
	{"M",
	 "qR݂̂tS",
	 "ЂƂт݂̂䂫҂Ȃ"},
	{"[",
	 "݂̌킫ė ",
	 "݂ƂĂ"},
	{"@b",
	 "R͓~т܂肯",
	 "l߂ʂƎvւ"},
	{"}͓ZP",
	 "SĂɐ܂΂܂ޏ",
	 "܂ǂ͂锒ẻ"},
	{"p",
	 "L̂Ȃʂ",
	 "ł΂肤̂͂Ȃ"},
	{"㐥",
	 "ڂ炯Ľƌ܂ł",
	 "g̗ɂӂ锒"},
	{"t",
	 "Rɕ̂邵݂",
	 "ւʂ݂Ȃ肯"},
	{"I@F",
	 "v̌̂ǂt̓",
	 "ÐSȂԂ̎U"},
	{"",
	 "Nmlɂލ",
	 "ނ̗FȂȂ"},
	{"I@єV",
	 "l͂Sm炸ӂ邳Ƃ",
	 "Ԃނ̍ɂɂقЂ"},
	{"[{",
	 "Ă̖͂܂ЂȂ疾ʂ",
	 "_̂ÂɌǂ"},
	{"N",
	 "Iɕ̐H̖",
	 "ʂƂ߂ʋʂU肯"},
	{"E@",
	 "YgΎv͂ЂĂ",
	 "l̖̐ɂ邩"},
	{"Qc@",
	 "󊝐̂̂̂̌̂Ԃ",
	 "܂ĂȂǂl̗"},
	{"@",
	 "̂ԂǐFɏołɂ킪",
	 "̂vӂƐl̖ӂ܂"},
	{"p",
	 "Ăӂ킪͂܂ɂ",
	 "lmꂸvЂ߂"},
	{"",
	 "_肫Ȃ݂ɑڂ",
	 "̏RgƂ"},
	{"[֒",
	 "ЌĂ̌̐SɂԂ",
	 "̂͂̂v͂肯"},
	{"[",
	 "ӂƂ̐₦ĂȂ͂ȂȂ",
	 "lg݂܂"},
	{"",
	 "͂Ƃӂׂl͎vق",
	 "ĝÂɂȂʂׂ"},
	{"]HD",
	 "Rǂ̂Ƃ킽Ml",
	 "smʗ̓"},
	{"bc@t",
	 "dނ炵ĥт",
	 "lˏH͂ɂ"},
	{"@dV",
	 "݊₤ĝ̂̂",
	 "ӂĂ̂vӂ납"},
	{"咆b\钩b",
	 "_qm̂΂̖͂",
	 "͏̂v @"},
	{"`F",
	 "Nߐɂ炴肵",
	 "ȂȂƎvЂ邩"},
	{"b",
	 "Ƃɂ͈ɐ̂",
	 "m炶ȔRvЂ"},
	{"Mb",
	 "ʂΕ̂Ƃ͒mȂ",
	 "Ȃٍ߂ڂ炯"},
	{"E叫j",
	 "VЂƂʂ̖Ԃ",
	 "ɋv̂Ƃ͒m"},
	{"VOi",
	 "Yꂶ̍s܂ł͓",
	 "̖Ƃ"},
	{"[C",
	 "̉͐₦ċvȂʂ",
	 "ĂȂٕ"},
	{"a򎮕",
	 "炴ނ̐̂ق̎vЏo",
	 "ЂƂт̈ӂƂ"},
	{"",
	 "肠ЂČ₻Ƃ킩ʊԂ",
	 "_ɂ锼̌"},
	{"O",
	 "LnR̂",
	 "łlY͂"},
	{"Ԑq",
	 "₷͂ŐQȂ܂̂X",
	 "X܂ł̌"},
	{"",
	 "]R̓̉",
	 "܂ӂ݂V̋"},
	{"ɐ",
	 "ɂւ̓ޗǂ̓s̔d",
	 "dɓЂʂ邩"},
	{"[",
	 "߂Ē̂特͂͂Ƃ",
	 "Ɉ̊ւ͂邳"},
	{"v",
	 "͂vА₦ȂނƂ΂",
	 "lÂĂȂŌӂ悵"},
	{"[藊",
	 "ڂ炯F̐얶",
	 "͂킽鐣X̖ԑ"},
	{"@",
	 "݂тقʑɂ̂",
	 "ɋȂޖɂ"},
	{"Oms",
	 "Ƃɂ͂Ǝv֎R",
	 "ԂقɒmlȂ"},
	{"h",
	 "t̖̖΂Ȃ薍",
	 "ЂȂޖɂ"},
	{"O@",
	 "SɂłɂȂւ",
	 "ׂ锼̌"},
	{"\@t",
	 "炵O̎R݂̂t",
	 "c̐̂ɂȂ肯"},
	{"ǝ@t",
	 "₵ɏh𗧂ołĂȂނ",
	 "ÂȂH̗["},
	{"[oM",
	 "[Ζc̈tƂÂ",
	 "̂܂ɏH"},
	{"SqeƋI",
	 "ɂt̕l̂g",
	 "⑳̔G"},
	{"[[",
	 "̔̏̍炫ɂ",
	 "OR̉Ȃ"},
	{"rb",
	 "肯l̎R낵",
	 "͂Ƃ͋Fʂ̂"},
	{"r",
	 "_肨I𖽂ɂ",
	 "͂ꍡN̏Hʂ߂"},
	{"@O֔b",
	 "킽̌ołČ΋v",
	 "_ɂ܂Ӊg"},
	{"@",
	 "͂݊ɂ",
	 "ĂɈ͂ނƂv"},
	{"",
	 "WHʂӐ璹̖",
	 "˂߂ʐ{̊֎"},
	{"v",
	 "HɂȂт_̐₦Ԃ",
	 "oÂ錎̉ê₯"},
	{"Ҍ@x",
	 "ȂސSm炸",
	 "č͂̂v"},
	{"㓿厛b",
	 "قƂƂ𒭂ނ",
	 "Ľ̂"},
	{"@t",
	 "vЂтĂ͂̂",
	 "JɊւʂ͗܂Ȃ肯"},
	{"c@{vr",
	 "̒擹ȂvГ",
	 "R̉ɂȂ"},
	{"㒩b",
	 "Ȃւ΂܂̍₵̂΂",
	 "Jƌ͗"},
	{"rb@t",
	 "̎vӍ͖",
	 "˂̂Ђ܂ւȂ肯"},
	{"s@t",
	 "ȂƂČ͂̂v͂",
	 "Ȃ킪܂"},
	{"@@t",
	 "ނ炳߂̘I܂Ђʂ܂̗t",
	 "̂ڂH̗["},
	{"cÖ@ʓ",
	 "g]̈̂˂̈",
	 "gĂЂ킽ׂ"},
	{"qe",
	 "ʂ̏Ȃΐ₦˂Ȃւ",
	 "EԂ邱Ƃ̂"},
	{"ux@",
	 "΂ȗŶ܂̑ɂ",
	 "GɂGꂵF͕ς炸"},
	{"㋞ɐېOb",
	 "肬肷⑚̂ނ",
	 "߂ЂƂ肩Q"},
	{"@]",
	 "킪͒ɂ݂ʉ̐΂",
	 "lmˊԂȂ"},
	{"qEb",
	 "̒͏ɂȏ",
	 "܂̏M̍j肩Ȃ"},
	{"Qco",
	 "݂悵̎ȐHӂ",
	 "ӂ邳Ɗ߂Ȃ"},
	{"Om~",
	 "قȂ̖ɂقӂ",
	 "킪[ɖn̑"},
	{"Ob",
	 "Ԃӂ炵̒̐Ȃ",
	 "ӂ䂭͉̂䂪gȂ肯"},
	{"[",
	 "ʐl܂ق̉Y̗[Ȃ",
	 "Ă⑔̐g"},
	{"]ʉƗ",
	 "悮Ȃ̗̏[",
	 "݂Ă̂邵Ȃ肯"},
	{"㒹H@",
	 "lɂl߂Ȃ",
	 "vӂɂ̎vӐg"},
	{"@",
	 "S~Â[̂̂Ԃɂ",
	 "Ȃق܂肠̂Ȃ肯"},
};

const char* const kan_num[N_CARD + 1] = {
	"ZZ","Z","Z","ZO","Zl","Z","ZZ","Z","Z","Z",
	"Z","","","O","l","","Z","ꎵ","ꔪ","",
	"Z","","","O","l","","Z","","","",
	"OZ","O","O","OO","Ol","O","OZ","O","O","O",
	"lZ","l","l","lO","ll","l","lZ","l","l","l",
	"܁Z","܈","ܓ","܎O","܎l","܌","ܘZ","܎","ܔ","܋",
	"ZZ","Z","Z","ZO","Zl","Z","ZZ","Z","Z","Z",
	"Z","","","O","l","","Z","","","",
	"Z","","","O","l","","Z","","","",
	"Z","","","O","l","","Z","㎵","㔪","",
	"@S",
};

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int now;				/* O[o^C} */
int joy;				/* pbh */

extern const unsigned char PAT[];
//extern const unsigned char BG[];
TEXTURE pat;
//TEXTURE bg;

unsigned char gbuff[DISP_X * DISP_Y];	/* wiWJVRAM */
unsigned char tbuff[DISP_X * DISP_Y];	/* eLXgVRAM */

int hiscore;

#define N_SEL	4			/* I̐ */
#define N_GRP	25			/* wi̐   */
typedef struct _GI {
	int seed;			/* V[h */
	int score;			/*  */
	int q_no;			/* ԍ(0`99܂ŃJEgAbv) */
	int sel;			/* I */
	int g_no;			/* ݕ\ĂOtBbNԍ(0:Ȃ) */

	int q[N_CARD];			/* 胊Xg */
	int s[N_SEL];			/* ݂̖ɑ΂I */
} GI;
GI gi;

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
int demo();
void game();
void gdraw(int no);
void update0();
void update1();
void update2();
void trans();

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo() != 0) break;
		game();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init(&render, &surface, 0, 0, 0, 0, 0, 0, 0);

#ifdef USE_MUSIC
	/* yCu܂B */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

/*{{AvP[VL̏*/
	turbo(1); /* S48MHz[h */
	srand(pceTimerGetCount());
	/* rbg}bvB */
	texture_init(&pat, PAT);
	render.context->texture = &pat; /* eNX`Œ */
	//texture_init(&bg, BG);
	/* RAMR[h]ischedule()łē]Ă܂j */
	FRAMCOPY(V_FRAM4, fram4_code);
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
#endif /*USE_MUSIC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
#define PAUSE_COLOR	0x130		/* PAUSEJ[(wip) */
//#define PAUSE_COLOR	0x203		/* PAUSEJ[(wip) */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int pause, x, y;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		/*{{pceLCDTrans()FRAM4GAj󂳂̂ŁAē]*/
		/*  yield()ŃVXej[Ă΂ƁA̒pceLCDTrans()Ă΂̂ŁA */
		/*  FRAM4̍ē]yield()̌ōsKv܂B */
		FRAMCOPY(V_FRAM4, fram4_code);
		/*}}pceLCDTrans()FRAM4GAj󂳂̂ŁAē]*/
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
	now++;	/* O[o^C}XV */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

#undef PAUSE_FONT
#undef PAUSE_COLOR
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y
}

/****************************************************************************
 *	demo
 ****************************************************************************/

int
demo()
{
	int result, i, j, n;
	unsigned char* p;
	char str[32];

	memset(tbuff, -1, sizeof tbuff);
	//
	sprintf(str, "ō_%s", kan_num[hiscore]);
	tprint(2, 2, str, 0);
	sprintf(str, "_%s", kan_num[gi.score]);
	tprint(94, 2, str, 0);
	//
	tprint(20, DISP_Y - 28, "`{^@@Q[Jn@", 1);
	tprint(20, DISP_Y - 16, "ZNg@vOI", 1);
	//
	do {
		i = pceTimerGetCount() % N_GRP + 1/*OtBbNԍ1x[X*/;
	} while(i == 1); /* #1̓Q[Jn̊GȂ̂Ŕ */
	gdraw(i);

	result = 0;
	for(;;) {
		schedule();

		if(joy & TRG_A     ) { result =  0; sound_play(1, SND5); break; }
		if(joy & TRG_SELECT) { result = -1;                      break; }

		trans();
		render_object(&render,
			(DISP_X - PAT_TITLE_W) / 2, (DISP_Y / 2) - PAT_TITLE_H + 6,
			PAT_TITLE_SX, PAT_TITLE_SY, PAT_TITLE_W, PAT_TITLE_H, DRW_NOMAL);
	}

	memset(tbuff, -1, sizeof tbuff);
	for(i = 0; i < 8; i++) {
		schedule();
		if(i % 2 == 0) {
			p = gbuff;
			for(j = 0; j < sizeof vbuff; j++) {
				n = *p;
				if(n < 3) *p = n + 1;
				p++;
			}
		}
		trans();
	}
	memset(vbuff, 3, sizeof vbuff);
	schedule();

	return result;
}

/****************************************************************************
 *	game
 ****************************************************************************/

static void
game_init()
{
	unsigned char q[N_CARD];
	int i, r;

	/* ܂NAB */
	memset(&gi, 0, sizeof gi);

	/* V[hB */
	gi.seed = pceTimerGetCount();

	/* 胊Xg쐬B */
	for(i = 0; i < N_CARD; i++) q[i] = i;
	for(i = 0; i < N_CARD; i++) {
		r = RND16(gi.seed) % (N_CARD - i);
		gi.q[i] = q[r];
		memmove(&q[r], &q[r + 1], (N_CARD - i) - (r + 1));
	}
}

static void
q_init()
{
	int i, j, g_no;
	unsigned char s[N_SEL];

	/* I쐬B */
	s[0] = gi.q[gi.q_no];			/* s[0]   =       */
	for(i = 1; i < N_SEL; i++) {		/* s[1-4] = s    */
		do {				/*         (ds) */
			s[i] = RND16(gi.seed) % N_CARD;
			for(j = 0; j < i; j++) {
				if(s[i] == s[j]) break;
			}
		} while(j < i);
	}

	/* [e[gĊi[B */
	i = RND16(gi.seed) % N_SEL;
	for(j = 0; j < N_SEL; j++) {
		gi.s[(i + j) % N_SEL] = s[j];
	}

	/* wi`B */
	g_no = gi.q_no / ((N_CARD + (N_GRP - 1)) / N_GRP) + 1/*OtBbNԍ1x[X*/;
	if(gi.g_no != g_no) {
		gi.g_no = g_no;
		gdraw(g_no);
	}

	/* eLXg`B */
	gi.sel = 0; /* I#0ɖ߂ */
	update1();
}

void
game()
{
	const CARD* card;
	int i, j, m, n;
	unsigned char* p;

	pceWaveSetChAtt(0, 0);
	zmod_play("tam-y01");

	game_init();
	for(;;) {
		q_init();
		sound_play(2, SND2);
		for(;;) {
			schedule();

			if((joy & TRG_UP) && (0 < gi.sel)) {
				gi.sel--;
				sound_play(2, SND1);
				update1();
			}
			if((joy & TRG_DN) && (gi.sel < N_SEL - 1)) {
				gi.sel++;
				sound_play(2, SND1);
				update1();
			}
			if(joy & TRG_A) {
				/* ^s\ */
				if(gi.q[gi.q_no] == gi.s[gi.sel]) {
					gi.score++;
					sound_play(1, SND5);
					update1();
					for(i = 0; i < SEC(0.5); i++) {
						trans();
						render_object(&render,
							(DISP_X - PAT_CORRECT_W) / 2, (DISP_Y - PAT_CORRECT_H) / 2,
							PAT_CORRECT_SX, PAT_CORRECT_SY, PAT_CORRECT_W, PAT_CORRECT_H, DRW_NOMAL);
						schedule();
						if(joy & TRG_B) break;
					}
				} else {
					sound_play(1, SND3);
					update1();
					for(i = 0; i < SEC(0.5); i++) {
						trans();
						render_object(&render,
							(DISP_X - PAT_ERROR_W) / 2, (DISP_Y - PAT_ERROR_H) / 2,
							PAT_ERROR_SX, PAT_ERROR_SY, PAT_ERROR_W, PAT_ERROR_H, DRW_NOMAL);
						schedule();
						if(joy & TRG_B) break;
					}
				}
				/* ̕\ */
				card = &card_list[gi.q[gi.q_no]];
				update2();
				for(i = 0; i < SEC(3); i++) {
					trans();
					schedule();
					if(joy & TRG_B) break;
				}
				break;
			}
			if(joy & TRG_SELECT) goto L_EXIT; /* Q[~ */

			trans();
		}
		gi.q_no++;
		if(gi.q_no == N_CARD) break;
	}
L_EXIT:
	m = 0;
	update0();
	for(i = 0; i < SEC(0.25); i++) {
		schedule();
		if(m < 127) {
			m++;
			pceWaveSetChAtt(0, m);
		}
		if(joy & (TRG_A | TRG_B)) break;
		trans();
	}
	for(i = 0; i < 8; i++) {
		schedule();
		if(m < 127) {
			m++;
			pceWaveSetChAtt(0, m);
		}
		if(i % 2 == 0) {
			p = gbuff;
			for(j = 0; j < sizeof vbuff; j++) {
				n = *p;
				if(n < 3) *p = n + 1;
				p++;
			}
		}
		trans();
	}
	for(i = 0; i < SEC(0.25); i++) {
		schedule();
		if(m < 127) {
			m++;
			pceWaveSetChAtt(0, m);
		}
		if(joy & (TRG_A | TRG_B)) break;
		trans();
	}
	tprint((DISP_X - 7 * 9) / 2 - 2, (DISP_Y - 7) / 2 - 2, "f`ld@nudq", 1);
	for(i = 0; i < SEC(2.5); i++) {
		schedule();
		if(m < 127) {
			m++;
			pceWaveSetChAtt(0, m);
		}
		if(joy & (TRG_A | TRG_B)) break;
		trans();
	}
	update0();
	for(i = 0; i < SEC(0.25); i++) {
		schedule();
		if(m < 127) {
			m++;
			pceWaveSetChAtt(0, m);
		}
		if(joy & (TRG_A | TRG_B)) break;
		trans();
	}
	memset(vbuff, 3, sizeof vbuff);
	schedule();
	mod_stop();
	pceWaveSetChAtt(0, 0);

	/* nCXRAXVB */
	if(gi.score > hiscore) hiscore = gi.score;
}

/****************************************************************************
 *	gdraw
 ****************************************************************************/

void
gdraw(int no)
{
	char fname[32];
	TEXTURE img;
	RENDER rend;
	SURFACE surf;

	/* wiC[W[hB */
	sprintf(fname, "grp/jpn%03d-2d.pgd", no);
	if(my_unzip(DAT_FNAME, fname, _def_vbuff, sizeof _def_vbuff) == 0) DIE();
	texture_init(&img, _def_vbuff);

	/* `pӁB */
	surf.w = DISP_X;
	surf.h = DISP_Y;
	surf.vbuff = gbuff;
	surf.zbuff = NULL;
	render_init(&rend, &surf, 0, 0, 0, 0, 0, 0, 0);

	/* wiC[W`B */
	rend.context->texture = &img;
	render_object(&rend, 0, 0, 0, 0, DISP_X, DISP_Y, DRW_NOMAL);
}

/****************************************************************************
 *	update
 ****************************************************************************/

void
update0()
{
	char str[32];
	int i;

	/* ܂NA */
	memset(tbuff, -1, sizeof tbuff);

	/* ԍ */
	i = gi.q_no + 1;
	if(i >  N_CARD) { /* ŏIĨtF[hAEg͂ */
		sprintf(str, "SI");
	} else if(i == N_CARD) {
		sprintf(str, "ŏI");
	} else {
		sprintf(str, "%s", kan_num[i]);
	}
	tprint(2, 2, str, 0);

	/* _ */
	sprintf(str, "_%s", kan_num[gi.score]);
	tprint(94, 2, str, 0);
}

void
update1()
{
	const CARD* card;
	int i;

	update0();

	/* ̋ */
	card = &card_list[gi.q[gi.q_no]];
	tprint( 4,  17, card->kami, 1);

	/* ̋ */
	for(i = 0; i < N_SEL; i++) {
		card = &card_list[gi.s[i]];
		tprint(4 + 7, 17 + 14 * (1 + i), card->simo, i == gi.sel);
	}
}

void
update2()
{
	const CARD* card;

	update0();

	card = &card_list[gi.q[gi.q_no]];
	tprint( 4    , 26     , card->kami, 1);
	tprint( 4 + 7, 26 + 14, card->simo, 1);
	tprint(DISP_X - (strlen(card->name) / 2) * 7 - 8, 26 + 28, card->name, 1);

	tprint(40, DISP_Y - 13, "a{^ŃXLbv܂", 0);
}

/****************************************************************************
 *	trans
 ****************************************************************************/

void
trans()
{
	/* pɂɎĝŁA̎ԂĂA
	 * [JɒuȂiȁHj
	 */
	const unsigned char cnvtbl[4][8] = {
		/*dst=0*/{0,0,0,0,0,0,0,1},
		/*dst=1*/{0,1,1,1,1,1,1,2},
		/*dst=2*/{1,2,2,2,2,2,2,3},
		/*dst=3*/{2,3,3,3,3,3,3,3},
	};
	unsigned char c, *pv, *pt, *pg;
	int i;

	pv = vbuff;
	pt = tbuff;
	pg = gbuff;
	for(i = 0; i < DISP_X * DISP_Y; i++) {
		c = *pt;
		if(c > 3) { /* eLXgVRAM̓ߕȂwi\ */
			c = cnvtbl[*pg][(RND16(gi.seed) >> 8) & 7];
		}
		*pv = c;
		pv++;
		pt++;
		pg++;
	}
}
